(* array_demo.ml : demostrate array syntax *)
open Printf;;

(***** BLOCK 1 *****)
let arr = [|10; 20; 30; 40|] in    (* immediate initialization *)
let len = Array.length arr in      (* length calculation *)
printf "Length is %d\n" len;

(***** BLOCK 2 *****)
for i=0 to len-1 do
  let eli = arr.(i) in             (* access elements with arr.(i) *)
  printf "El %d : %d\n" i eli; 
done;

(***** BLOCK 3 *****)
printf "Doubling elements\n";      (* elements are mutable by default *)
for i=0 to len-1 do
  arr.(i) <- arr.(i) * 2;          (* assign with arr.(i) <- expr *)
  printf "El %d : %d\n" i arr.(i);
done;

(***** BLOCK 4 *****)
let elem = "Monsier: répéter!" in  
let big = Array.make 100 elem in   (* 100 long array, filled with elem *)
for i=0 to (Array.length big)-1 do (* iterate over elements *)
  printf "%s\n" big.(i);           (* printing them *)
done;
;;
