(* ref_summing.ml : demonstrate use of mutable refs to sum *)
open Printf;;

(* generate the sum of numbers 1 to n *)
let sum_1_to_n n =
  let sum = ref 0 in            (* initialize ref to 0 *)
  for i=1 to n do               (* loop *)
    let next = !sum + i in      (* add on i to current sum *)
    sum := next;                (* assign sum to next *)
    (* sum := !sum + i; *)      (* one-liner version *)
  done;
  !sum                          (* return value of sum *)
;;

let sum10 = sum_1_to_n 10 in
let sum50 = sum_1_to_n 50 in
printf "summing 1 to 10 gives %d\n" sum10;
printf "summing 1 to 50 gives %d\n" sum50;
;;
