(* Demonstrate rudimentary scanf usage  *)

open Printf;;
open Scanf;;

(* identity function *)
let ident x = x;;

printf "What's your name?\n%!";         
(* prompt, %! flushes output *)

let name = bscanf Scanning.stdin "%s" ident in
(* read a string from standard input, process it with the identity
   function, bind result to 'name' *)

printf "'%s' - what a pretty name!\n" name;
(* output name that was read *)
;;
